<?
/*
Plugin Name: LaTeX Renderer
Plugin URI: ask e.tasci -/att/- fisek.com.tr
Description: This is a very simple plugin that converts the LaTeX code written in the entry btw [tex] ... [/tex] tags into png.
		Requires MikTeX and ImageMagick installed properly to run. (I'm running this on a windows system by the way)

Author: Emre S. Tasci (adapted from Titus Barik's Code)  Code and almost everything else taken from Titus Barik's �LaTeX Equations and Graphics in PHP� article in Linux Journal (01/03/2005) (http://www.linuxjournal.com/article/7870)
where he refers to (http://www.linuxjournal.com/article/8011)
TeX Converter, LatexRender -  www.mayer.dial.pipex.com/tex.htm 
textogif -  www.fourmilab.ch/webtools/textogif/textogif.html 
mimeTeX -  www.forkosh.com/mimetex.html 
A Guide To LaTeX, Third Edition, Addison-Wesley 
PSTricks -  www.pstricks.de 
ImageMagick -  www.imagemagick.org 
MathML -  What's in it for us?: tech.irt.org/articles/js081 


Version: 1.0
Author URI: http://www.emresururi.com
*/
class render {
 var $LATEX_PATH = "\"c:/program files/MikTex 2.5/miktex/bin/latex.exe\"";
 var $DVIPS_PATH = "\"c:/program files/MikTex 2.5/miktex/bin/dvips.exe\"";
 var $CONVERT_PATH = "c:/Progra~1/ImageMagick-6.3.7-Q16/convert.exe";
 var $TMP_DIR =
   "c:/temp";
 var $CACHE_DIR =
   "c:/progra~1/apache~1/apache2.2/htdocs/latex_cache";
 var $URL_PATH = "/latex_cache";
 
function wrap($thunk) {
  return <<<EOS
    \documentclass[10pt]{article}
    % add additional packages here
    \usepackage{amsmath}
    \usepackage{amsfonts}
    \usepackage{amssymb}
    %\usepackage{pst-plot}
    %\usepackage{color}
    \pagestyle{empty}
    \begin{document}
    $thunk
    \end{document}
EOS;
}
function cleanup($hash) {
  $current_dir = getcwd();
  chdir($this->TMP_DIR);
  unlink($this->TMP_DIR . "/$hash.tex");
  unlink($this->TMP_DIR . "/$hash.aux");
  unlink($this->TMP_DIR . "/$hash.log");
  unlink($this->TMP_DIR . "/$hash.dvi");
  unlink($this->TMP_DIR . "/$hash.ps");
  unlink($this->TMP_DIR . "/$hash.png");
  chdir($current_dir);
}
function transform($text) {
  preg_match_all("/\[tex\](.*?)\[\/tex\]/si", $text, $matches);
  for ($i = 0; $i < count($matches[0]); $i++) {
    $position = strpos($text, $matches[0][$i]);
    $thunk = $matches[1][$i];    
    $hash = md5($thunk);
    $full_name = $this->CACHE_DIR . "/" .
                 $hash . ".png";
    $url = $this->URL_PATH . "/" .
           $hash . ".png";
    if (!is_file($full_name)) {
    $thunk = $matches[1][$i];
    $thunk = str_replace("&amp;","&",$thunk);
    $thunk = str_replace("&nbsp;","",$thunk);
    //$thunk = str_replace("<br />","",$thunk);
    //$thunk = str_replace("</p>","",$thunk);
    $thunk = preg_replace('@<[\/\!]*?[^<>]*?>@si', '', $thunk);
      $this->render_latex($thunk, $hash);
      $this->cleanup($hash);
    }
    $text = substr_replace($text,
      "<img src=\"$url\" alt=\"Formula: ".str_replace("\n","",$thunk)."\" />",
      $position, strlen($matches[0][$i]));
  }
  return $text;
}
function render_latex($thunk, $hash) {
  $thunk = $this->wrap($thunk);
  $current_dir = getcwd();
  chdir($this->TMP_DIR);
  // create temporary LaTeX file
  $fp = fopen($this->TMP_DIR . "/$hash.tex", "w+");
  fputs($fp, $thunk);
  fclose($fp);
  // run LaTeX to create temporary DVI file
  $command = $this->LATEX_PATH .
             " --interaction=nonstopmode " .
             $hash . ".tex";
  //echo $command; 
  exec($command);
  // run dvips to create temporary PS file
  $command = $this->DVIPS_PATH .
             " -E $hash" .
             ".dvi -o " . "$hash.ps";
  
  exec($command);
  // run PS file through ImageMagick to
  // create PNG file
  $command = $this->CONVERT_PATH .
             " -density 120 $hash.ps $hash.png";
  
  exec($command);
  // copy the file to the cache directory
  copy("$hash.png", $this->CACHE_DIR . "/$hash.png");
  chdir($current_dir);
}
}
function renderu($text)
{
   if (get_magic_quotes_gpc())
      $text = stripslashes($text);
      $text = stripslashes($text);
   $render = new render();
   return (addslashes($render->transform($text)));
}

add_filter('content_save_pre', 'renderu', 1, 1);
?>
